package com.sjkj.appthreefloor_tsgz.net;

import android.content.Context;

import com.sjkj.appthreefloor_tsgz.bean.ResureDetailsBean;
import com.sjkj.base_lib.entity.Params;
import com.sjkj.base_lib.entity.ResponseBean;
import com.sjkj.base_lib.net.RetrofitFactory;
import com.sjkj.base_lib.net.data.exception.BusinessException;
import com.sjkj.base_lib.net.domain.interactor.UseCase;
import com.sjkj.base_lib.utils.AppTools;

import rx.Observable;
import rx.functions.Func1;

/**
 * 资源详情
 */
public class ResureDetailsRequest extends UseCase {
    private Context context;
    private RetrofitService service;

    private Params params;

    public Params getParams() {
        return params;
    }

    public void setParams(Params params) {
        this.params = params;
    }

    public ResureDetailsRequest(Context context) {
        this.context = context;
        service = RetrofitFactory.getRetrofit(AppTools.getBaseUrl()).create(RetrofitService.class);
    }

    @Override
    protected Observable buildUseCaseObservable() {
        return service.resureDetails(params).flatMap(new Func1<ResponseBean<ResureDetailsBean>, Observable<ResureDetailsBean>>() {
            @Override
            public Observable<ResureDetailsBean> call(ResponseBean<ResureDetailsBean> responseBean) {
                if (!ResponseBean.CODE_SUCCESS.
                        equals(responseBean.getCode())) {
                    return Observable.error(new BusinessException(responseBean.getMsg()));
                }
                return Observable.just(responseBean.getData());
            }
        });
    }
}
